#!/bin/bash
# create a data base cluster for ex2

EXDATA_PATH=~postgres
SCRIPT_PATH=$(cd $(dirname $0);pwd)

for FILE_NAME in $(find {.,/usr/local/pgsql} -name postmaster.pid)
do
  pg_ctl stop -w -D $(dirname $FILE_NAME) -m f
done
rm -rf $EXDATA_PATH/ex2_a
rm -rf $EXDATA_PATH/ex2_b

initdb -D $EXDATA_PATH/ex2_a -E UTF8 --no-locale
sed -e "s/#logging_collector = off/logging_collector = on/" \
    -e "s/#log_line_prefix = ''/log_line_prefix = '%t[%p] '/" \
    -e "s/#silent_mode = off/silent_mode = on/" \
    -e "s/#listen_addresses = 'localhost'/listen_addresses = '*'/" \
    -e "s/#wal_level = minimal/wal_level = hot_standby/" \
    -e "s/#max_wal_senders = 0/max_wal_senders = 1/" \
    -e "s/#wal_keep_segments = 0/wal_keep_segments = 8/" \
  $EXDATA_PATH/ex2_a/postgresql.conf > $EXDATA_PATH/postgresql.conf.dist
mv $EXDATA_PATH/postgresql.conf.dist $EXDATA_PATH/ex2_a/postgresql.conf
cat << EOF > $EXDATA_PATH/ex2_a/pg_hba.conf
# TYPE  DATABASE        USER            CIDR-ADDRESS            METHOD
host    replication    postgres          127.0.0.1/32           trust
local    all             all                                    trust
host     all             all             127.0.0.1/32           trust
EOF

pg_ctl start -w -D $EXDATA_PATH/ex2_a
createdb ex2
psql -f $SCRIPT_PATH/ex2.init.sql ex2
psql -c "SELECT pg_start_backup('replication_base', true)"
cp -r $EXDATA_PATH/ex2_a $EXDATA_PATH/ex2_b
psql -c "SELECT pg_stop_backup()"
rm -rf $EXDATA_PATH/ex2_b/postmaster.* $EXDATA_PATH/ex2_b/pg_xlog/* 

sed -e "s/#port = 5432/port = 5433/" \
    -e "s/#hot_standby = off/hot_standby = on/" \
  $EXDATA_PATH/ex2_b/postgresql.conf > $EXDATA_PATH/postgresql.conf.dist
mv $EXDATA_PATH/postgresql.conf.dist $EXDATA_PATH/ex2_b/postgresql.conf
cat << EOF > $EXDATA_PATH/ex2_b/recovery.conf
standby_mode = 'on'
primary_conninfo = 'host=localhost port=5432 user=postgres'
trigger_file = '/tmp/ex2_trigger'
EOF
pg_ctl start -w -D $EXDATA_PATH/ex2_b
