#!/bin/bash
# create a data base cluster for ex3

EXDATA_PATH=~postgres
SCRIPT_PATH=$(cd $(dirname $0);pwd)

for FILE_NAME in $(find {.,/usr/local/pgsql} -name postmaster.pid)
do
  pg_ctl stop -w -D $(dirname $FILE_NAME) -m f
done
rm -rf $EXDATA_PATH/ex3

initdb -D $EXDATA_PATH/ex3 -E UTF8 --no-locale
cp $EXDATA_PATH/ex3/postgresql.conf $EXDATA_PATH/ex3/postgresql.conf.ORG
cat <<'EOF' >> $EXDATA_PATH/ex3/postgresql.conf

# ex3
max_connections = 250
fsync = off
checkpoint_segments = 32
EOF

pg_ctl start -w -D $EXDATA_PATH/ex3 -o "-p 5434"
createdb -p 5434 ex3
psql -p 5434 -f $SCRIPT_PATH/ex3.init.sql ex3
pg_ctl stop -D $EXDATA_PATH/ex3
mv $EXDATA_PATH/ex3/postgresql.conf.ORG $EXDATA_PATH/ex3/postgresql.conf

sed -e "s/#logging_collector = off/logging_collector = on/" \
    -e "s/#log_line_prefix = ''/log_line_prefix = '%t[%p] '/" \
    -e "s/#silent_mode = off/silent_mode = on/" \
    -e "s/#listen_addresses = 'localhost'/listen_addresses = '*'/" \
 $EXDATA_PATH/ex3/postgresql.conf > postgresql.conf.dist
mv postgresql.conf.dist $EXDATA_PATH/ex3/postgresql.conf

cp $SCRIPT_PATH/ex3?.sql $EXDATA_PATH/
