#!/bin/bash
# create a data base cluster for ex4

EXDATA_PATH=~postgres

for FILE_NAME in $(find {.,/usr/local/pgsql} -name postmaster.pid)
do
  pg_ctl stop -w -D $(dirname $FILE_NAME) -m f
done
rm -rf $EXDATA_PATH/ex4

initdb -D $EXDATA_PATH/ex4 -E UTF8 --no-locale
pg_ctl -D $EXDATA_PATH/ex4 -o "-p 5434" -w start
pgbench -i -p 5434
pg_ctl -D $EXDATA_PATH/ex4 stop

sed -e "s/#logging_collector = off/logging_collector = on/" \
    -e "s/#log_line_prefix = ''/log_line_prefix = '%t[%p] '/" \
    -e "s/#silent_mode = off/silent_mode = on/" \
    -e "s/#listen_addresses = 'localhost'/listen_addresses = '*'/" \
 $EXDATA_PATH/ex4/postgresql.conf > postgresql.conf.dist
mv postgresql.conf.dist $EXDATA_PATH/ex4/postgresql.conf

dd if=/dev/urandom of=$EXDATA_PATH/ex4.tmp1 bs=8192 count=1

PGDB=`ls $EXDATA_PATH/ex4/base | tail -1`

for TARGET in `ls $EXDATA_PATH/ex4/base/$PGDB/[0-9]*[0-9]`
do
 cp $TARGET $EXDATA_PATH/ex4.tmp2
 cat $EXDATA_PATH/ex4.tmp1 $EXDATA_PATH/ex4.tmp2 > $TARGET
done

R=$(((RANDOM%40)+1))
echo $R
TARGET=`ls $EXDATA_PATH/ex4/global/* | head -n $R | tail -1`
dd if=/dev/urandom of=$EXDATA_PATH/ex4.tmp1 bs=1024 count=1
cp $TARGET $EXDATA_PATH/ex4.tmp2
cat $EXDATA_PATH/ex4.tmp1 $EXDATA_PATH/ex4.tmp2 > $TARGET

rm $EXDATA_PATH/ex4.tmp1 $EXDATA_PATH/ex4.tmp2
rm $EXDATA_PATH/ex4/pg_xlog/0*1
